[NOIP2015 普及组] 推销员
作者:互联网
因为pj组的题目是在太nb把我虐哭了所以来写一写题解
https://www.luogu.com.cn/problem/P2672
正常人的思路是枚举在哪转, 枚举了之后就选最大的准没错。
然后60ptsTLE飞起
贪心思路:我感觉正常的没什么人可以想到把。
首先可以证明, 如果按A值排序, 选最大的几个, 这样子贪心一定是错的qaq (但是能拿到90pts???)
为什么会错? 可能存在选出一个小的, 但是他的S值比较大。 (替换掉一个)
可以证明(口胡)绝对只可能换一个。 因为如果换两个, S值没变, A值变小了
所以我们每种只要预处理个, \(O(n)\) 递推就好了
#include <bits/stdc++.h>
using namespace std;
const int N= 100005;
struct Node
{
int s, t;
}a[N];
int s[N], pre[N], h[N], ans[N];
bool cmp(Node a, Node b)
{
return a.t> b.t;
}
int main()
{
int n; cin>> n;
for(int i= 1; i<= n; i++ ) scanf("%d", &a[i].s);
for(int i= 1; i<= n; i++ ) scanf("%d", &a[i].t);
sort(a+ 1, a+ n+ 1, cmp);
for(int i= 1; i<= n; i++ ) s[i]= s[i- 1]+ a[i].t; //前缀和
for(int i= 1; i<= n; i++ ) pre[i]= max(pre[i- 1], a[i].s* 2); //前缀
for(int i= n; i>= 1; i-- ) h[i]= max(h[i+ 1], a[i].s* 2+ a[i].t); //后缀
for(int i= 1; i<= n; i++ )
ans[i]= max(s[i]+ pre[i], s[i- 1]+ h[i]);
for(int i= 1; i<= n; i++ ) printf("%d\n", ans[i]);
return 0;
}
我们可以先贪心地排序, 再通过确定一个值分类讨论。
标签:Node,NOIP2015,int,可以,普及,枚举,推销员,排序,贪心 来源: https://www.cnblogs.com/lqt1217/p/15412852.html